<template>
  <div
    v-if="
      !popularGamesThemeProperty.IsHidden &&
      lobbyGames.PopularGamesForDisplay.length > 0
    "
    class="flex flex-col w-full pt-10"
  >
    <div class="flex items-center justify-between mb-4">
      <span class="text-2xl font-bold --text2">{{
        `${
          popularGamesThemeProperty.Text !== "Hot Games"
            ? popularGamesThemeProperty.Text
            : $t("hot_games")
        }`
      }}</span>
      <nuxt-link to="/games" class="text-base fc-primary"
        >{{ $t("see_all")
        }}<font-awesome-icon class="ml-3" icon="arrow-right-long"
      /></nuxt-link>
    </div>
    <div class="grid items-center grid-cols-7 gap-4">
      <button
      v-for="(item, index) in lobbyGames.PopularGamesForDisplay"
      :key="index"
      class="w-full relative aspect-[1/1] rounded-2xl overflow-hidden group before__content before__hot__content"
      @click="authenticated
              ? handleGameEntryOpenWindow(item, 850, 850)
              : redirectToLogin()"
      >
          <IconFavorite
            :gameData="item"
            :checkIsFavourite="checkIsFavourite"
            :redirectToLogin="redirectToLogin"
            :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
          <div class="bg-background1">
            <img
                v-lazy="item.GameIconUrl"
                class="w-full relative aspect-[1/1] rounded-2xl object-cover"
                :alt="item.GameName"
              />
          </div>
          <div class="play__now__overlay group-hover:opacity-100 pb-4 items-end">
            <span class="play__now__content_for_animate bg-primary">{{ $t("play_now") }}</span>
          </div>
      </button>
      </div>
  </div>
  <div
    v-if="
      !newGamesThemeProperty.IsHidden &&
      lobbyGames.NewGamesForDisplay.length > 0
    "
    class="flex flex-col w-full pt-10"
  >
    <div class="flex items-center justify-between mb-4">
      <span class="text-2xl font-bold --text2">{{
        `${
          newGamesThemeProperty.Text !== "New Games"
            ? newGamesThemeProperty.Text
            : $t("new_games")
        }`
      }}</span>
      <nuxt-link to="/games?f=New Games" class="text-base fc-primary"
        >{{ $t("see_all")
        }}<font-awesome-icon class="ml-3" icon="arrow-right-long"
      /></nuxt-link>
    </div>
    <div class="grid items-center grid-cols-7 gap-4">
      <button
        v-for="(item, index) in lobbyGames.NewGamesForDisplay"
        :key="index"
        class="w-full relative aspect-[1/1] rounded-2xl overflow-hidden group before__content before__new__content"
        @click="authenticated
              ? handleGameEntryOpenWindow(item, 850, 850)
              : redirectToLogin()"
      >
          <IconFavorite
            :gameData="item"
            :checkIsFavourite="checkIsFavourite"
            :redirectToLogin="redirectToLogin"
            :setAndUnsetGameToFavourite="setAndUnsetGameToFavourite"/>
          <div class="bg-background1">
            <img
                v-lazy="item.GameIconUrl"
                class="w-full relative aspect-[1/1] rounded-2xl object-cover"
                :alt="item.GameName"
              />
          </div>
          <div class="play__now__overlay group-hover:opacity-100 pb-4 items-end">
            <span class="play__now__content_for_animate bg-primary">{{ $t("play_now") }}</span>
          </div>
      </button>
      </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import _ from "lodash";
import apis from "@/utils/apis";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertiesHelper from "@/utils/themePropertyHelper";
import { GameBsi, IGameBsi } from "@/models/bsiGameList";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";

export default defineComponent({
  props: {
    isAnimateBtn: {
      type: Boolean,
      default: false,
    },
    usePrimaryColor: {
      type: Boolean,
      default: false,
    }
  },
  setup(props) {
    const authenticated = computed(() => store.state.auth);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const popularGamesThemeProperty = computed(
      (): IThemePropertiesFromApi =>
        themePropertiesHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_3"
        )
    );
    const newGamesThemeProperty = computed(
      (): IThemePropertiesFromApi =>
        themePropertiesHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_4"
        )
    );
    const popularGames = ref<Array<IGameBsi>>([]);
    const newGames = ref<Array<IGameBsi>>([]);
    const getTopGameListInitial = async () => {
      try {
        const response = await apis.getHotGameList();
        if (response.isSuccessful) {
          popularGames.value = _.sortBy(
            response.Data.Games.map((item) => new GameBsi(item)),
            "Rank"
          ).slice(0, 7);
        }
      } catch (error) {
        popularGames.value = [];
      }
    };
    getTopGameListInitial();
    const getNewGameListInitial = async () => {
      try {
        const response = await apis.getNewGameList();
        if (response.isSuccessful) {
          newGames.value = _.sortBy(
            response.Data.Games.map((item) => new GameBsi(item)),
            "Rank"
          ).slice(0, 7);
        }
      } catch (error) {
        newGames.value = [];
      }
    };
    getNewGameListInitial();
    const lobbyGames = computed(() => ({
      PopularGamesForDisplay: popularGames.value,
      NewGamesForDisplay: newGames.value,
    }));
    const isGameLoading = computed(() => store.state.isGameUpdateLoading);
    const router = useRouter();
    const {
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      redirectToLogin,
    } = useAddToFavorite();
    const textColorClass = props.usePrimaryColor ? 'fc-primary' : '--text-2';
    return {
      lobbyGames,
      isGameLoading,
      authenticated,
      popularGamesThemeProperty,
      newGamesThemeProperty,
      handleGameEntryOpenWindow,
      redirectToLogin,
      setAndUnsetGameToFavourite,
      checkIsFavourite,
      textColorClass,
    };
  },
});
</script>

<style lang="postcss" scoped>
.before__content {
  @apply before:z-[11] before:absolute before:top-0 before:left-0 before:px-[7px] before:py-[3px] before:rounded-tl-lg before:rounded-br-2xl before:text-white before:text-[16px]
  before:w-[56px] before:h-[26px] before:flex before:items-center before:justify-center;
}
.before__new__content {
  @apply before:content-['NEW'] before:bg-[#2A71DC];
}
.before__hot__content {
  @apply before:content-['HOT'] before:bg-[#FF264D];
}

.play__now__overlay {
  @apply opacity-0 group-hover:opacity-100 transition-opacity duration-[250ms] absolute top-0 z-10 w-full h-full grid rounded-lg justify-center bg-[#05071ecc];
}

.play__now__content {
  @apply flex justify-center items-center bg-green-500 text-sm font-bold text-white rounded-full h-8 w-[120px];
}
.play__now__content_for_animate {
  @apply flex justify-center items-center text-sm font-bold text-white rounded-md h-8 w-[120px];
}
</style>
